unit hiMTStrTbl; { MT-   }

interface

uses Windows, Messages, Share, Win, Debug, ListEdit, Kol,
     hiIconsManager, hiMST_DrawManager, hiMST_SelfDrawManager;
     
const
  AColor: array [0..15] of TColor = (clBlack, clMaroon, clGreen, clOlive,
                                     clNavy, clPurple, clTeal, clGray,
                                     clSilver, clRed, clLime, clYellow,
                                     clBlue, clFuchsia, clAqua, clWhite);

const
  ITM_ADD     =  -3;
  ITM_INSERT  =  -4;
  ITM_REPLACE =  -5;

  COL_NAME    =  -9;
  COL_WIDTH   = -10;
  COL_IMAGE   = -11;
  COL_ALIGN   = -12;

 {$EXTERNALSYM HDFT_ISSTRING}
  HDFT_ISSTRING     = $000; //test     // HD_ITEM.pvFilter points to a HD_TEXTFILTER 

  HDF_SORTUP        = $0400;
  HDF_SORTDOWN      = $0200;

//  HDM_LAYOUT        = HDM_FIRST + 5; //test

//  HDN_FIRST = -300;
//  HDN_FILTERCHANGE     = HDN_FIRST - 12;

  HDI_TEXT          =  $0002;
  HDI_FILTER        =  $0100; 

//  LVN_FIRST         = -100;
  LVN_BEGINSCROLL   = LVN_FIRST - 80; // test
  LVN_ENDSCROLL     = LVN_FIRST - 81; // test

  HDS_HORZ      = $0000;           //test
  HDS_BUTTONS   = $0002;           //test
  HDS_HOTTRACK  = $0004;           //test
  HDS_DRAGDROP  = $0040;           //test
  HDS_FILTERBAR = $0100;           //test
  HDS_FLAT      = $0200;           //test
  HDS_FULLDRAG  = $0080;           //test
  HDS_NOSIZING  = $0800;           //test
  HDS_OVERFLOW  = $1000;           //test

type                               
  TIMSTControl = record
    ctrlpoint:      function: pointer of object;
    actionitm:      procedure(var Data: TData; Mode: integer) of object;
    actioncol:      procedure(var Data: TData; Mode: integer) of object;    
    propercol:      procedure(var Data: TData; Mode: integer) of object;
    textalign:      function(idx: integer): TTextAlign of object;    
    smiconlist:     function: PImageList of object;
    lgiconlist:     function: PImageList of object;    
    colcount:       function: integer of object;
    imgsize:        function: byte of object;
    coloritems:     function: boolean of object;
    scoloritems:    procedure(val: boolean) of object;
    textbkcolor:    function: TColor of object;
    textcolor:      function: TColor of object;
    bkcolor:        function: TColor of object;
    shadowcolor:    function: TColor of object;
    iconcolcolor:   function: TColor of object;
    addcols:        procedure(var _Data: TData) of object;
    stextbkcolor:   procedure(Value: TColor) of object;
    stextcolor:     procedure(Value: TColor) of object;
    sbkcolor:       procedure(Value: TColor) of object;
    sshadowcolor:   procedure(Value: TColor) of object;
    siconcolcolor:  procedure(Value: TColor) of object;
    deletecol:      procedure(var _Data: TData) of object;
    clistclear:     procedure of object;
    clistcount:     function: integer of object;
    clistitems:     function(ind: integer): string of object;
    style:          function: TListViewStyle of object;
    setfocus:       procedure(var _Data: TData; Index: word) of object;
    getnewcuridx:   function: integer of object;
    setnewcuridx:   procedure(value: integer) of object;
    getfredaction:  function: boolean of object;
    getfctl3d:      function: boolean of object;
    matrix:         procedure(var _Data: TData) of object;
    mxget:          function(x, y: integer): TData of object;
    mxset:          procedure(x, y: integer; var Val: TData) of object;
    detachwndproc:  procedure of object;
    getstring:      function(index: integer): TData of object;
    columnarray:    procedure(var _Data: TData) of object;
    nidxicon:       function: integer of object;
    ncolorrow:      function: integer of object;
    codepageget:    function(str: string): string of object;    
  end;
  IMSTControl = ^TIMSTControl;
///////////////////////////////////////////////////// test  
  PHDLayout = ^_HD_LAYOUT;
  _HD_LAYOUT = record 
    prc   : ^TRect;
    pwpos : PWINDOWPOS;
  end;

  PHDTEXTFILTER = ^tagHDTEXTFILTER;
  tagHDTEXTFILTER = packed record
   pszText    : LPSTR;    // [in] pointer to the buffer containing the filter (ANSI)
   cchTextMax : integer;  // [in] max size of buffer/edit control buffer
  end;
  HDTEXTFILTER = tagHDTEXTFILTER;
     
  PHDItemA = ^THDItemA;
  PHDItemW = ^THDItemW;
  PHDItem  = PHDItemA;

  {$EXTERNALSYM _HD_ITEMA}
  _HD_ITEMA = packed record
   Mask       : Cardinal;
   cxy        : Integer;
   pszText    : LPSTR;
   hbm        : HBITMAP;
   cchTextMax : Integer;
   fmt        : Integer;
   lParam     : LPARAM;
   iImage     : Integer;   // index of bitmap in ImageList
   iOrder     : Integer;   // where to draw this item
   _type      : UINT;      // [in] filter type (defined what pvFilter is a pointer to)
   pvFilter   : pointer;   // [in] fillter data see above
  end;
  {$EXTERNALSYM _HD_ITEMW}
  _HD_ITEMW = packed record
   Mask       : Cardinal;
   cxy        : Integer;
   pszText    : LPWSTR;
   hbm        : HBITMAP;
   cchTextMax : Integer;
   fmt        : Integer;
   lParam     : LPARAM;
   iImage     : Integer;  // index of bitmap in ImageList
   iOrder     : Integer;  // where to draw this item
   _type      : UINT;     // [in] filter type (defined what pvFilter is a pointer to)
   pvFilter   : pointer;  // [in] fillter data see above
  end;
  {$EXTERNALSYM _HD_ITEM}
  _HD_ITEM = _HD_ITEMA;
  THDItemA = _HD_ITEMA;
  THDItemW = _HD_ITEMW;
  THDItem  = THDItemA;
  {$EXTERNALSYM HD_ITEMA}
  HD_ITEMA = _HD_ITEMA;
  {$EXTERNALSYM HD_ITEMW}
  HD_ITEMW = _HD_ITEMW;
  {$EXTERNALSYM HD_ITEM}
  HD_ITEM  = HD_ITEMA;

  PNMHEADER = ^tagNMHEADERA;
  tagNMHEADERA = record
  hdr : NMHDR;
  case integer of
   1: (iItem: integer; iButton: integer; pitem: PHDITEMA);
   2: (Item: integer; Button: integer);
  end; 
  NMHEADER  = tagNMHEADERA;
  HD_NOTIFY           = NMHEADER;   //test
  THDNotify           = HD_NOTIFY;  //test
  PHDNotify           = ^HD_NOTIFY; //test

{  tagNMCUSTOMDRAWINFO  = record
   hdr         : NMHDR;
   dwDrawStage : DWORD;
   hdc         : HDC;
   rc          : TRECT;
   dwItemSpec  : DWORD;
   uItemState  : UINT;
   lItemlParam : LPARAM;
  end;
} 
  NMCUSTOMDRAW      = tagNMCUSTOMDRAWINFO; 
  PNMTTCUSTOMDRAW   = ^tagNMTTCUSTOMDRAW;

  tagNMTTCUSTOMDRAW = record
   nmcd       : NMCUSTOMDRAW;
   uDrawFlags : UINT;
  end;

  tagNMLISTVIEW = record
   hdr          : NMHDR;
   iItem        : integer;
   iSubItem     : integer;
   uNewState    : UINT;
   uOldState    : UINT;
   uChanged     : UINT;
   ptAction     : TPOINT;
   lParam       : LPARAM;
   end;
   NMLISTVIEW   = tagNMLISTVIEW;
   LPNMLISTVIEW = ^tagNMLISTVIEW;
   TNMLISTVIEW  = tagNMLISTVIEW;
   PNMLISTVIEW  = ^tagNMLISTVIEW; 

   tagNMLVCUSTOMDRAW = record
    nmcd         : NMCUSTOMDRAW;
    clrText      : COLORREF;
    clrTextBk    : COLORREF;
    iSubItem     : integer;
    dwItemType   : DWORD;
    clrFace      : COLORREF;
    iIconEffect  : integer;
    iIconPhase   : integer;
    iPartId      : integer;
    iStateId     : integer;
    rcText       : TRect;
    uAlign       : UINT;// Alignment. Use LVGA_HEADER_CENTER, LVGA_HEADER_RIGHT, LVGA_HEADER_LEFT
   end;
   NMLVCUSTOMDRAW   = tagNMLVCUSTOMDRAW;
   LPNMLVCUSTOMDRAW = ^tagNMLVCUSTOMDRAW;
   TNMLVCUSTOMDRAW  = tagNMLVCUSTOMDRAW;
   PNMLVCUSTOMDRAW  = ^tagNMLVCUSTOMDRAW;

   _HD_HITTESTINFO = record
   case integer of
    1: (pt: TPOINT; flags: UINT; iItem: integer);
    { delphi }
    2: (point: TPOINT; dummyflags: UINT; Item: integer);
   end;
   HDHITTESTINFO        = _HD_HITTESTINFO;
   HD_HITTESTINFO       = _HD_HITTESTINFO;
   LPHDHITTESTINFO      = ^_HD_HITTESTINFO;
   THD_HITTESTINFO      = _HD_HITTESTINFO;
   PHD_HITTESTINFO      = ^_HD_HITTESTINFO;
   THDHitTestInfo       = THD_HITTESTINFO;
   PHDHitTestInfo       = LPHDHITTESTINFO; 

////////////////////////////////////////////////////////test
type
  ThiMTStrTbl = class(THIWin)

  protected
    procedure _OnDestroy(Sender:PObj); override;
    
  private
    mtstc: TIMSTControl; 

    FData_1: TData;

    GMouse: boolean;
    FLargIconsManager,
    FSmallIconsManager,
    FStateIconsManager: IIconsManager;

    Sel,
    FNIdxIcon,
    FNColorRow,
    NewCurIdx,
    NewLine,
    FColumnWidth: integer;

    LgIList,
    SmIList,
    StIList: PImageList;

    _ColDlm: Char;
    
    dblClick,//test
    FColorItems,
    FGrid,
    FTrackSelect,
    FMultiSelect,
    FImgColumn,
    FRedaction,
    FEnableOnClick,
    FInfoTip: boolean;    

    FImgSize,
    FColumnClick: byte;

    HFontColor,//test
    FTextColor,
    FTextBkColor,
    FBkColor,
    FIconColColor: TColor;

    CList: PStrList;
    Obj: PMatrix;
    CLArray: PArray;
    FStyle: TListViewStyle;
    FTextAlign: TTextAlign;
    hHeaderFont: THandle;//test 
    
    procedure SetHeaderFont;//test
    procedure EventFilterText(IndEvent: byte; var Msg: TMsg; lpnmcd: PNMTTCustomDraw);//test
    procedure EventColumnResize(IndEvent: byte; var Msg: TMsg);//test
    function  ctrlpoint: pointer;
    function  smiconlist: PImageList;
    function  lgiconlist: PImageList;
    function  textalign(idx: integer): TTextAlign;
    function  colcount: integer;
    function  imgsize: byte;    
    function  coloritems: boolean;
    procedure scoloritems(val: boolean);    
    function  textbkcolor: TColor;
    function  textcolor: TColor;
    function  bkcolor: TColor;
    function  iconcolcolor: TColor;
    procedure addcols(var _Data: TData);
    procedure stextcolor(Value: TColor);
    procedure stextbkcolor(Value: TColor);
    procedure sbkcolor(Value: TColor);
    procedure siconcolcolor(Value: TColor);
    procedure deletecol(var _Data: TData);
    procedure clistclear;
    function  clistcount: integer;
    function  clistitems(ind: integer): string;
    function  style: TListViewStyle;
    function  getnewcuridx: integer;
    procedure setnewcuridx(value: integer);
    function  getfredaction: boolean;
    function  getfctl3d: boolean;
    procedure detachwndproc;    
    procedure matrix(var _Data: TData);
    procedure columnarray(var _Data: TData);
    function  nidxicon: integer;
    function  ncolorrow: integer;

    procedure ColDlm(Val: string);    
    procedure NoSizingColumns(Val: string);//test
    
    procedure _OnClick(Obj:PObj);
    procedure _OnMouseDown(Sender: PControl; var Mouse: TMouseEventData); override;
    procedure _OnMouseUp(Sender: PControl; var Mouse: TMouseEventData); override;         
    procedure _onDblClick(Sender: PControl; var Mouse: TMouseEventData); override;

    procedure SetColumns(const ListCol: PStrList; Mode:integer);
    procedure _OnColumnClick(Sender: PControl; Idx: Integer);
    procedure _OnBeforeLineChange(Sender: PControl; Idx: Integer);
    procedure _OnLineChange(Sender: PControl; Idx: Integer);
    function  _OnLVCustomDraw(Sender: PControl; DC: HDC; Stage: Cardinal;
                              ItemIdx, SubItemIdx: Integer; const Rect: TRect;
                              ItemState: TDrawState;
                              var TextColor, BackColor: TColor): Cardinal;

    procedure MX_Set(x, y: integer; var Val: TData);
    function  MX_Get(x, y: integer): TData;
    function  _mRows: integer;
    function  _mCols: integer;

    function  InitColStr(var Val: string):string;
    procedure _SetCol(var Item: TData; var Val: TData);
    function  _GetCol(Var Item: TData; var Val: TData):boolean;
    procedure _AddCol(var Val: TData);
    function  _CountCol: integer;
    procedure SetTextColLst(const Value: string);
    function  Get(index: integer): TData;
    function  CodePageGet(str: string): string;

    procedure SetOption(OSet: boolean; Option: TListViewOption); 

    procedure _OnSelState(Sender: PControl; IdxFrom, IdxTo: Integer; OldState, NewState: cardinal);

    procedure ActionItm(var Data: TData; Mode: integer);
    procedure ActionCol(var Data: TData; Mode: integer);
    procedure ProperCol(var Data: TData; Mode: integer);

    procedure SetLargIconsManager(value: IIconsManager);
    procedure SetSmallIconsManager(value: IIconsManager);
    procedure SetStateIconsManager(value: IIconsManager);
    
    function  AssignIList: boolean;

  public
    _data_CodePageSet,
    _data_CodePageGet,
    _data_Row,
    _data_Col,
    _event_onClickFilterBtn,//test
    _event_onChangeFilterText,//test
    _event_onBeginColumnResize,//test
    _event_onEndColumnResize,//test
    _event_onColumnResize,//test
    _event_onColumnChange,//test
    _event_onMouseStop,//test
    _event_onSelect,
    _event_onClientRect,
    _event_onClick,
    _event_onColumnClick,
    _event_onCheck,
    _event_onLineChange,
    _event_onBeforeLineChange:THI_Event;

    _prop_HeaderFilterBar,//test     
    _prop_HeaderButtons,//test
    _prop_HeaderSizing,//test
    _prop_Scroll,
    _prop_FlatScroll,
    _prop_CheckBoxes,
    _prop_RowSelect,
    _prop_VirtualTab,
    _prop_HeaderDragDrop,
    _prop_DoubleBuffered:boolean;  

    _prop_HeaderCountString,//test
    _prop_HeaderPadding,//test
    _prop_Row,
    _prop_Col: integer;

    _prop_DrawManager: IDrawManager;
    _prop_SelfDrawManager: ISelfDrawManager;//test
    _prop_FontHeader: TFontRec;

    property _prop_LargIconsManager:IIconsManager   read FLargIconsManager  write SetLargIconsManager;
    property _prop_SmallIconsManager:IIconsManager  read FSmallIconsManager write SetSmallIconsManager;
    property _prop_StateIconsManager:IIconsManager  read FStateIconsManager write SetStateIconsManager;

    property _prop_NIdxIcon: integer        write FNIdxIcon;
    property _prop_NColorRow: integer       write FNColorRow;

    property _prop_ColorItems: boolean      write FColorItems;
    property _prop_InfoTip: boolean         write FInfoTip;
    property _prop_EnableOnClick: boolean   write FEnableOnClick;
    property _prop_ColumnWidth: integer     write FColumnWidth;
    property _prop_Redaction: boolean       write FRedaction;
    property _prop_ImgColumn: boolean       write FImgColumn;
    property _prop_ColumnClick: byte        write FColumnClick;
    property _prop_TextAlign: TTextAlign    write FTextAlign;
    property _prop_Style: TListViewStyle    write FStyle;
    property _prop_Grid: boolean            write FGrid;
    property _prop_TrackSelect: boolean     write FTrackSelect;
    property _prop_MultiSelect: boolean     write FMultiSelect;
    property _prop_ColDelimiter: string     write ColDlm;
    property _prop_Columns: string          write SetTextColLst;
    property _prop_NoSizingColumns: string  write NoSizingColumns;//test

    procedure Init; override;

    function getInterfaceMSTControl: IMSTControl;

    procedure _work_doClearFilter(var _Data: TData; Index: word);//test
    procedure _work_doFilterTime(var _Data: TData; Index: word);//test
    procedure _work_doStyle(var _Data: TData; Index: word);
    procedure _work_doGrid(var _Data: TData; Index: word);
    procedure _work_doInfoTip(var _Data: TData; Index: word);
    procedure _work_doTrackSelect(var _Data: TData; Index: word);
    procedure _work_doMultiSelect(var _Data: TData; Index: word);
    procedure _work_doEnableOnClick(var _Data: TData; Index: word);
    procedure _work_doColor(var _Data: TData; Index: word);
    procedure _work_doClientRect(var _Data: TData; Index: word);    

    procedure _work_doNIdxIcon(var _Data: TData; Index: word);
    procedure _work_doNColorRow(var _Data: TData; Index: word);
    procedure _work_doHeaderSizing(var _Data: TData; Index: word);//test
    procedure _work_doNoSizingColumns(var _Data: TData; Index: word);//test

    procedure _var_MTStrTbl(var _Data: TData; Index: word);
    procedure _var_TopItem(var _Data: TData; Index: word);
    procedure _var_PerPage(var _Data: TData; Index: word);
    procedure _var_ItemAtPos(var _Data: TData; Index: word);
    procedure _var_Count(var _Data: TData; Index: word);
    procedure _var_Index(var _Data: TData; Index: word);
    procedure _var_Select(var _Data: TData; Index: word);
    procedure _var_CountCol(var _Data: TData; Index: word);
    procedure _var_EndIdx(var _Data: TData; Index: word);     
    procedure _var_EndIdxCol(var _Data: TData; Index: word); 
    procedure _var_HandleHeader(var _Data: TData; Index: word);//test
  end;

var hHeader: THandle;//test
    HeaderOldProc: TFarProc;//test
    iHeaderHieght: integer;//test
    bHeaderSizing:boolean;//test
    ArrNoSizCol: array of integer;
implementation

function HeaderWndProc(h: THandle; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;//test
const
    HHT_ONHEADER = $0002;
    HDM_HITTEST  = HDM_FIRST + 6;
var phdl: PHDLayout; 
    prct: PRect; 
    pwp: PWindowPos; 
    hti: THDHITTESTINFO;
    pt: TPoint;
    i: integer;
begin
    Result := CallWindowProc(HeaderOldProc, h, uMsg, wParam, lParam); 
    if uMsg = 4613{HDM_LAYOUT} then begin
     phdl := PHDLayout(lParam); 
     prct := PRect(phdl.prc); 
     pwp := PWindowPos(phdl.pwpos); 
     if pwp.cy = 0 then exit;  //  style  lvsDetails  
     //pwp.x := pwp.x + 1;       //   (header)       
     pwp.cy := pwp.y + iHeaderHieght;   //   (header)
     prct.top := pwp.cy - 2;   //     (header) 
    end;
    if uMsg = WM_SETCURSOR then
     if not bHeaderSizing then SetCursor(LoadCursor(0,IDC_ARROW))//     
     else begin
      GetCursorPos(pt);
      ScreenToClient(h, pt);
      hti.Point:=pt;
      SendMessage(h, HDM_HITTEST, 0, cardinal(@hti));
      for i := 0 to Length(ArrNoSizCol) - 1 do 
       if hti.Item = ArrNoSizCol[i] then SetCursor(LoadCursor(0,IDC_ARROW));//   
    end;
end;

function ThiMTStrTbl.AssignIList;
begin
  Result := (Assigned(SmIlist) and (Control.LVStyle <> lvsIcon)) or
            (Assigned(LgIlist) and (Control.LVStyle = lvsIcon));
end;

function ThiMTStrTbl.getInterfaceMSTControl;
begin
  Result := @mtstc;
end;

function ThiMTStrTbl.ctrlpoint;
begin
  Result := Control;
end;

function ThiMTStrTbl.textalign;
begin
  Result := Control.LVColAlign[idx];
end;

function ThiMTStrTbl.smiconlist;
begin
   if Assigned(SmIList) then
     Result := SmIList
   else
     Result := nil;
end;

function ThiMTStrTbl.lgiconlist;
begin
   if Assigned(LgIList) then
     Result := LgIList
   else
     Result := nil;
end;

function ThiMTStrTbl.colcount;
begin
  Result := CList.Count;
end;

function ThiMTStrTbl.clistitems;
begin
  Result := Clist.Items[ind];
end;

function ThiMTStrTbl.imgsize;
begin
  Result := FImgSize;
end;

function ThiMTStrTbl.coloritems;
begin
  Result := FColorItems;
end;

procedure ThiMTStrTbl.scoloritems;
begin
  FColorItems := val;
end;

function ThiMTStrTbl.textcolor;
begin
  Result := FTextColor;
end;

function ThiMTStrTbl.textbkcolor;
begin
  Result := FTextBkColor;
end;

function ThiMTStrTbl.bkcolor;
begin
  Result := FBkColor;
end;

function ThiMTStrTbl.iconcolcolor;
begin
  Result := FIconColColor;
end;

function ThiMTStrTbl.style;
begin
  Result := FStyle;
end;

function ThiMTStrTbl.getnewcuridx;
begin
  Result := NewCurIdx;
end;

procedure ThiMTStrTbl.setnewcuridx;
begin
   NewCurIdx := Value;
end;

function ThiMTStrTbl.getfredaction;
begin
  Result := FRedaction;
end;

procedure ThiMTStrTbl.siconcolcolor;
begin
  FIconColColor := Value;
  if Assigned(SmIList) then
    SmIList.BkColor := FIconColColor;
  SetColumns(CList, 1);      
end;

function ThiMTStrTbl.clistcount;
begin
  Result := CList.Count;
end;

function ThiMTStrTbl.getfctl3d;
begin
  Result := not boolean(_prop_CTL3D);
end;

procedure ThiMTStrTbl.addcols; // 
var
  s: string;
  ColIdx: integer;
begin
  case _Data.Data_type of
    data_null: exit;
  end;
  ColIdx := 0;
  while not _IsNULL(_Data) do
  begin
    s := ReadString(_Data, Null);
    if ((ColIdx <> FNColorRow) or not FColorItems) and ((ColIdx <> FNIdxIcon) or not AssignIList) then
    begin
      Control.LVColAdd('', FTextAlign, FColumnWidth);
      CList.Add(InitColStr(s));
    end;  
    Inc(ColIdx);
  end;
  SetColumns(CList, 1);
end;

procedure ThiMTStrTbl.clistclear;
begin
  Clist.Clear;
end;

function ThiMTStrTbl.nidxicon;
begin
  Result := FNIdxIcon;
end;

function ThiMTStrTbl.ncolorrow;
begin
  Result := FNColorRow;
end;

procedure ThiMTStrTbl._onDestroy;
var
  Item: integer;
begin
  for Item := 0 to Control.Count - 1 do
  begin
    if Assigned(PData(Control.LVItemData[Item])) then
    begin
      FreeData(PData(Control.LVItemData[Item]));
      Dispose(PData(Control.LVItemData[Item]));
    end;
  end;
  CList.free;
  if Obj <> nil then
    Dispose(Obj);
  if CLArray <> nil then
    Dispose(CLArray);
  FreeData(@FData_1);  

  if hHeaderFont > 0 then DeleteObject(hHeaderFont);            //test    
  SetWindowLong(hHeader, GWL_WNDPROC, Longint(HeaderOldProc));     //test   
  inherited;
end;

function ThiMTStrTbl.CodePageGet;
var
  ds: TData;
begin
  if Assigned(_data_CodePageGet.Event) then
  begin
    dtString(ds, str);
    _ReadData(ds, _data_CodePageGet);
    Result := ToString(ds);
  end  
  else
    Result := str;
end;

procedure ThiMTStrTbl._OnColumnClick;
begin
  case FColumnClick of
    0: _hi_OnEvent(_event_onColumnClick, Control.LVColText[Idx]);
    1: _hi_OnEvent(_event_onColumnClick, Idx);
  end;
end;

procedure ThiMTStrTbl._OnBeforeLineChange;
var
  dt: TData;
begin
  dt := Get(Idx); 
  _hi_OnEvent_(_event_onBeforeLineChange, dt);
end;

procedure ThiMTStrTbl._OnLineChange;
var
  dt: TData;
begin
  dt := Get(Idx);
  _hi_OnEvent_(_event_onLineChange, dt);
end;

//---------------------       -----------------------

procedure ThiMTStrTbl._OnClick;
begin
   if (Control.LVCurItem <> -1)and (sel = Control.LVCurItem) and FEnableOnClick then
     _hi_OnEvent(_event_onClick,Control.LVCurItem);
end;

procedure ThiMTStrTbl._OnMouseDown;
begin
   sel := Control.LVCurItem;
   GMouse := true;
   inherited;
end;

procedure ThiMTStrTbl._OnMouseUp;
begin
   GMouse := false;
   inherited;
end;

procedure ThiMTStrTbl._onDblClick;
begin
   GMouse := true;
   inherited;
end;

procedure ThiMTStrTbl._OnSelState;
var
  dt, Data: TData;
begin
  dtNull(Data);
TRY
  if (Newstate = 3) or (Newstate = 1) then
  begin
    if  FEnableOnClick then _hi_OnEvent(_event_onClick, IdxFrom);
    _hi_OnEvent(_event_onSelect, IdxFrom);
    exit;
  end;

  if GMouse and (OldState = 0) then
  begin 
    Sender.LVItemStateImgIdx[IdxFrom] := 0;
    exit;    
  end;
  if (Newstate = $2000) and (OldState = $1000) then
    dtInteger(dt, 1)
  else if (Newstate = $1000) and (OldState = $2000) then
    dtInteger(dt, 0)
  else
    exit;         
  dtInteger(Data, IdxFrom);
  Data.ldata := @dt;
  _hi_onEvent_(_event_onCheck, Data);
FINALLY
  GMouse := false;
END;  
end;

//---------------------       -----------------------

function ThiMTStrTbl._OnLVCustomDraw;
var
  Color, bkColor: TColor;
  idxColor: Cardinal;
  FData: TData;                                            
begin   
//   _hi_OnEvent(_event_onClick, int2str(Stage) + ' ' + int2str(DC)+ ' ' + int2str(ItemIdx));//del
//    Result :=  CDRF_NOTIFYSUBITEMDRAW OR CDRF_NOTIFYPOSTPAINT;
  Result := CDRF_DODEFAULT;

  if Assigned(_prop_SelfDrawManager) then Result := _prop_SelfDrawManager.customdrawitem
 (Sender, DC, Stage, ItemIdx, SubItemIdx, Rect, ItemState, TextColor, BackColor, NewCurIdx, SmIList, StIList);

  if (Stage = CDDS_PREPAINT) then Result := CDRF_NOTIFYITEMDRAW  OR CDRF_NOTIFYPOSTPAINT
   else if (Stage = CDDS_ITEMPREPAINT) then begin 
TRY
{    BackColor := Color2RGB(FTextBkColor);
    TextColor := Color2RGB(FTextColor);
    if Assigned(PData(Sender.LVItemData[ItemIdx])) and FColorItems and (Sender.Count <> 0) then
     if (Sender.LVItemData[ItemIdx] > 65535) then begin
      CopyData(@FData, PData(Sender.LVItemData[ItemIdx]));
      Color := ToInteger(FData);
      bkColor := $00FFFFFF and Color;
      idxColor := ($0F000000 and Color) shr 24;
      if bkColor <> 0 then BackColor := bkColor;
      if idxColor <> 0 then TextColor := AColor[idxColor];
      FreeData(@FData);  
     end;
}
    Result := CDRF_NOTIFYSUBITEMDRAW OR CDRF_NOTIFYPOSTPAINT;
    // or CDRF_NOTIFYPOSTERASE ;
    //Result := CDRF_SKIPPOSTPAINT; 
EXCEPT
END;
  end else begin 
   if ((Stage = CDDS_SUBITEM OR CDDS_ITEMPREPAINT) or (Stage = CDDS_ITEMPOSTPAINT))
        and ((Sender.LVStyle = lvsDetail) or (Sender.LVStyle = lvsDetailNoHeader))
        and Assigned(_prop_DrawManager) then
   Result := _prop_DrawManager.customdraw(Sender, DC, Stage, ItemIdx, SubItemIdx, Rect, ItemState,
                                           TextColor, BackColor, NewCurIdx, SmIList, StIList);
 end;

end;
//-------------------    ---------------------

//------------------------------------------------------------------------

procedure ThiMTStrTbl.ColDlm;
begin
  if Val = '' then
    _ColDlm := '='
  else
    _ColDlm := Val[1];
end;
//==============================================================================

procedure ThiMTStrTbl.EventFilterText(IndEvent: byte; var Msg: TMsg; lpnmcd: PNMTTCustomDraw);//test
var   dText, Data, dName: TData;
      PHdr: PNMHEADER;
      hdTextFilter : PHDTEXTFILTER;
      hdItem: THDItem;
      bufFilter: array [0..128] of Char;
begin
    PHdr := PNMHEADER(Msg.LParam);
    FillChar(hdItem, SizeOf(THDItem), 0); 
    hdItem.Mask  := HDI_FILTER;
    hdItem._type := HDFT_ISSTRING;
    hdTextFilter := New(PHDTextFilter);
    hdTextFilter.pszText := @bufFilter;
    hdTextFilter.cchTextMax := SizeOf(bufFilter) - 1;
    hdItem.pvFilter := hdTextFilter;
    if SendMessage(lpnmcd^.nmcd.hdr.hwndFrom, HDM_GETITEMA, PHdr.iItem, LPARAM(@hdItem)) = 1 then
     begin //      
      dtInteger(Data, PHdr.iItem);           //  
      dtString(dText, hdTextFilter.pszText); //  
      dtString(dName, Control.LVColText[PHdr.iItem]); //        
      Data.ldata := @dText;
      dText.ldata := @dName;
      case indEvent of
       0 :_hi_OnEvent(_event_onChangeFilterText, Data);
       1: _hi_OnEvent(_event_onClickFilterBtn, Data);
      end;
     end;
end;

procedure ThiMTStrTbl.EventColumnResize(IndEvent: byte; var Msg: TMsg);//test
var PHdr: PNMHEADER;
    Data, dWidth, dName: TData;
    Width: integer;
begin
    PHdr := PNMHEADER(Msg.LParam);
    if Assigned(PHDNotify(PHdr)^.pItem) and ((PHDNotify(PHdr)^.pItem^.mask and HDI_WIDTH) <> 0) then 
    Width := PHDNotify(PHdr)^.pItem^.cxy else Width := -1;
    dtInteger(Data, PHdr.iItem); //  
    dtInteger(dWidth, Width); //  
    dtString(dName, Control.LVColText[PHdr.iItem]); //  
    Data.ldata:= @dWidth;
    dWidth.ldata := @dName;    
    case indEvent of
     0: _hi_OnEvent(_event_onColumnChange, Data);
     1: _hi_OnEvent(_event_onBeginColumnResize, Data);
     2: _hi_OnEvent(_event_onEndColumnResize, Data);
     3: _hi_OnEvent(_event_onColumnResize, Data);
    end;
end;

function WndProcTabGrid(Sender: PControl; var Msg: TMsg; var Rslt: Integer): Boolean;
type
  TMouseDownPt = packed record
    X: Word;
    Y: Word;
  end;
var
  R, ARect: TRect;
  Pt: TMouseDownPt; 
  HTI: TLVHitTestInfo;
  fClass: ThiMTStrTbl;
  l: TListViewOptions;
  lpnmcd: PNMTTCustomDraw;//test
  PHdr: PNMHEADER;//test//del

  procedure EscCell(NewLine: integer);
  begin
    R := Sender.LVItemRect(NewLine, lvipBounds);
    ARect := Sender.LVItemRect(NewLine, lvipLabel);
    R.Left := ARect.Left;
    InvalidateRect(Sender.Handle, @R, false);
  end;

  function NoSizeColumn:boolean;//test 
  var   i: integer;
  begin
   result := false;
   if Length(ArrNoSizCol) = 0 then exit;
   PHdr := PNMHEADER(Msg.LParam);
   for i := 0 to Length(ArrNoSizCol) - 1 do begin
    if PHdr.iItem = ArrNoSizCol[i] then begin
     result := true;
     break;
    end;
   end;
  end;

begin
  Result := FALSE;
  l:= Sender.LVOptions;
  fClass := ThiMTStrTbl(Sender.Tag);
  with fClass do begin
   
   case Msg.message of
//    WM_ERASEBKGND: _debug('asdf');//del
    WM_NOTIFY: begin//test
     lpnmcd := PNMTTCustomDraw(Msg.LParam); 
//     _hi_OnEvent(_event_onMouseUp,lpnmcd^.nmcd.hdr.code);// del
     case lpnmcd^.nmcd.hdr.code of 
//      -160: _debug;
{-12} NM_CUSTOMDRAW: begin
    // _hi_OnEvent(_event_onMouseUp,lpnmcd^.nmcd.dwDrawStage);// del
                     if lpnmcd^.nmcd.hdr.hwndFrom = GetDlgItem(Sender.Handle,0) then begin // 
                      case lpnmcd^.nmcd.dwDrawStage of
                    {1}CDDS_PREPAINT:      if Assigned(_prop_SelfDrawManager) then _prop_SelfDrawManager.stagedraw(2);
                {65537}CDDS_ITEMPREPAINT:  SetTextColor(lpnmcd^.nmcd.hdc, Color2RGB(HFontColor)); //   
                {65538}CDDS_ITEMPOSTPAINT: if Assigned(_prop_SelfDrawManager) then
                                            _prop_SelfDrawManager.customdrawheader(
                                            lpnmcd^.nmcd.dwItemSpec,// 
                                            lpnmcd^.nmcd.rc,//  
                                            lpnmcd^.nmcd.uItemState,//   0 - , 1 - 
                                            Control.LVColText[lpnmcd^.nmcd.dwItemSpec]);//                                              
                    {2}CDDS_POSTPAINT:     if Assigned(_prop_SelfDrawManager) then _prop_SelfDrawManager.stagedraw(3);//   
                      end;
                     end else begin
                     case lpnmcd^.nmcd.dwDrawStage of
               {65537}CDDS_ITEMPREPAINT: begin
                                             SetBkMode(Sender.Handle, TRANSPARENT);
                                             SetTextColor(Sender.Handle, CLR_NONE);
                                             //SetTextBkColor(Sender.Handle, CLR_NONE);
                                     //ListView_SetTextBkColor(ListView1.Handle, CLR_NONE);
                                     //ListView_SetBKColor(ListView1.Handle, CLR_NONE);
                                           
                                           end;  
               {65538}//CDDS_ITEMPOSTPAINT: 
              {196609}//CDDS_SUBITEM or CDDS_ITEMPREPAINT: _debug('CDDS_SUBITEM or CDDS_ITEMPREPAINT ' + int2str(lpnmcd^.nmcd.dwDrawStage));
                      CDDS_SUBITEM: _debug('CDDS_SUBITEM ' + int2str(lpnmcd^.nmcd.dwDrawStage));
                   {1}CDDS_PREPAINT: if Assigned(_prop_SelfDrawManager) then _prop_SelfDrawManager.stagedraw(0);//  
                   {2}CDDS_POSTPAINT: if Assigned(_prop_SelfDrawManager) then _prop_SelfDrawManager.stagedraw(1);//   
                      //else _debug(lpnmcd^.nmcd.dwDrawStage);
                     end;
                    end;
                   end;
      //-310: _hi_OnEvent(_event_onBeginMoveHeader);//test //HDN_BEGINDRAG      HeaderDragDrop = true
      //-311: _hi_OnEvent(_event_onEndMoveHeader);//test //HDN_ENDDRAG     HeaderDragDrop = true
      -312: EventFilterText(0,Msg,lpnmcd);//test // HDN_FILTERCHANGE    
      -313: EventFilterText(1,Msg,lpnmcd);//test // HDN_FILTERBTNCLICK    
      -320: begin//test//              
             if (not bHeaderSizing or NoSizeColumn) and dblClick then begin
              dblClick := false;
              if Assigned(PHDNotify(PHdr)^.pItem) and ((PHDNotify(PHdr)^.pItem^.mask and HDI_WIDTH) <> 0) then 
               PHDNotify(PHdr)^.pItem^.cxy := Control.LVColWidth[PNMHEADER(Msg.LParam).iItem];
             end;
            end;  
      -321: begin//test//    
             //InvalidateRect(hHeader,nil, false);
             EventColumnResize(0, Msg);
            end;
      -325: begin//test//     
             dblClick := true;
             if bHeaderSizing then InvalidateRect(hHeader,nil, false);//  ,     
            end;
      -326: if not bHeaderSizing or NoSizeColumn//test//   
             then ReleaseCapture//     
             else EventColumnResize(1, Msg);
      -327: EventColumnResize(2, Msg);//test//   
      -328: EventColumnResize(3, Msg);//test//   
      -530: _hi_OnEvent(_event_onMouseStop,Control.LVItemAtPos(Ms.X, Ms.Y));//test//   
      //LVN_BEGINDRAG: _debug('begindrug');     
      //LVN_BEGINSCROLL: _debug('beginscroll');
      //LVN_ENDSCROLL: _debug('endscroll');
      //LVN_HOTTRACK: _debug('hottrack'); //       TrackSelect = True
      //LVN_COLUMNDROPDOWN: _debug;
      //LVN_GETDISPINFO: _debug;
      //LVN_COLUMNCLICK: _debug(int2str(lpnmcd^.nmcd.dwItemSpec)); //test    
      //NM_SETCURSOR:  _debug;//_hi_OnEvent(_event_onMouseUp,0); //test
      NM_CLICK: _hi_OnEvent(_event_onMouseUp,0);//test
      NM_RCLICK: _hi_OnEvent(_event_onMouseUp,1); //test
      //NM_HOVER: _debug('hover');
     end;
    end; 
    WM_RBUTTONDOWN, WM_LBUTTONDOWN:
     begin
      Pt:= TMouseDownPt(Msg.lParam);
      HTI.pt.x := Pt.X;
      HTI.pt.y := Pt.Y;
      Sender.Perform(LVM_SUBITEMHITTEST, 0, Integer(@HTI));
      if HTI.flags <> LVHT_ONITEMSTATEICON then begin 
       NewLine := HTI.iItem;
       NewCurIdx := HTI.iSubItem;             
      end;
      EscCell(NewLine);
     end;
    WM_KEYDOWN:
     begin
      Case Msg.WParam of
       VK_LEFT, VK_RIGHT:
        begin
         if (lvoRowSelect in l) then begin
          NewCurIdx := NewCurIdx + Msg.wParam - $26;
          if NewCurIdx >= Sender.LVColCount then NewCurIdx := Sender.LVColCount - 1
           else
           if NewCurIdx < 0 then NewCurIdx := 0;
          EscCell(NewLine);
         end;
        end;
       VK_UP, VK_DOWN:
        begin
         NewLine := NewLine + Msg.wParam - $27;                  
         if NewLine >= Sender.Count then NewLine := Sender.Count - 1
          else
           if NewLine < 0 then NewLine := 0;
         EscCell(NewLine);
        end;
      end;
     end;
    end;
  end;
end;

//==============================================================================

procedure ThiMTStrTbl.detachwndproc;
begin
  if Control.IsProcAttached(WndProcTabGrid) then Control.DetachProc(WndProcTabGrid);
end;

procedure ThiMTStrTbl.Init;
var
  l: TListViewOptions;
begin
  l := [lvoUnderlineHot, lvoAutoArrange];

  if not _prop_Scroll then
    include(l, lvoNoScroll);
  if FInfoTip then
    include(l, lvoInfoTip);
  if FTrackSelect then
    include(l, lvoTrackSelect);
  if _prop_HeaderDragDrop then
    include(l, lvoHeaderDragDrop);
  if _prop_CheckBoxes then
    include(l, lvoCheckBoxes);
  if FMultiSelect then
    include(l, lvoMultiSelect);
  if FGrid then
    include(l, lvoGridLines);
  if _prop_RowSelect then
    include(l, lvoRowSelect);
  if _prop_FlatScroll then
    include(l, lvoFlatsb);
  if _prop_VirtualTab then
    include(l, lvoOwnerData);

  FIconColColor  := clBtnFace;

  if _prop_StateIconsManager = nil then
    StIList := nil
  else 
    StIList := _prop_StateIconsManager.iconlist;

  if _prop_SmallIconsManager = nil then
    SmIList := nil
  else
  begin 
    SmIList  := _prop_SmallIconsManager.iconlist;
    FImgSize := _prop_SmallIconsManager.imgsz;
    SmIList.BkColor := FIconColColor;
  end;

  if _prop_LargIconsManager = nil then
    LgIList := nil
  else 
    LgIList := _prop_LargIconsManager.iconlist;

  if FRedaction then
    Control := NewListEdit(FParent, FStyle, l, LgIList, SmIList, StIList,
                           _OnLineChange, _OnBeforeLineChange)
  else
    Control := NewListView(FParent, FStyle, l, LgIList, SmIList, StIList);

  mtstc.ctrlpoint      := ctrlpoint;
  mtstc.actionitm      := ActionItm;
  mtstc.actioncol      := actioncol;
  mtstc.propercol      := ProperCol;
  mtstc.textalign      := textalign;
  mtstc.smiconlist     := smiconlist;
  mtstc.lgiconlist     := lgiconlist;  
  mtstc.colcount       := colcount;
  mtstc.imgsize        := imgsize;     
  mtstc.coloritems     := coloritems;
  mtstc.scoloritems    := scoloritems;
  mtstc.textbkcolor    := textbkcolor;
  mtstc.textcolor      := textcolor;
  mtstc.bkcolor        := bkcolor;
  mtstc.addcols        := addcols;
  mtstc.stextbkcolor   := stextbkcolor;
  mtstc.stextcolor     := stextcolor;
  mtstc.sbkcolor       := sbkcolor;
  mtstc.siconcolcolor  := siconcolcolor;
  mtstc.iconcolcolor   := iconcolcolor;  
  mtstc.deletecol      := deletecol;
  mtstc.clistclear     := clistclear;
  mtstc.clistcount     := clistcount;
  mtstc.style          := style;
  mtstc.setfocus       := _work_doSetFocus;
  mtstc.matrix         := matrix;
  mtstc.mxget          := MX_Get;
  mtstc.mxset          := MX_Set;  
  mtstc.getnewcuridx   := getnewcuridx;
  mtstc.setnewcuridx   := setnewcuridx;
  mtstc.getfredaction  := getfredaction;
  mtstc.getfctl3d      := getfctl3d;
  mtstc.detachwndproc  := detachwndproc;
  mtstc.getstring      := Get;
  mtstc.columnarray    := columnarray;
  mtstc.clistitems     := clistitems;
  mtstc.nidxicon       := nidxicon;
  mtstc.ncolorrow      := ncolorrow;
  mtstc.codepageget    := CodePageGet;

  GMouse := false;
  Control.OnMouseDown     := _OnMouseDown;
  Control.OnMouseUp       := _OnMouseUp;
  Control.OnMouseDblClk   := _onDblClick;
  Control.OnColumnClick   := _OnColumnClick;
  Control.OnClick         := _OnClick;
  Control.OnLVStateChange := _OnSelState;
  Control.OnLVCustomDraw  := _OnLVCustomDraw;
  SetColumns(CList,0);
  
  //test//      *   +    
  iHeaderHieght := _prop_HeaderCountString * _prop_FontHeader.Size + _prop_HeaderPadding * 2 + 6;//test
  if _prop_HeaderFilterBar then iHeaderHieght := iHeaderHieght + _prop_FontHeader.Size + 14;//test
  //8=20,10=18,12=12,14=10,18=8,24=9-12
  bHeaderSizing := _prop_HeaderSizing;
  
  hHeader := SendMessage(Control.Handle, LVM_GETHEADER, 0, 0);//test//  header 
  HeaderOldProc := FARPROC(GetWindowLong(hHeader, GWL_WNDPROC));//test
  SetWindowLong(hHeader, GWL_WNDPROC, Longint(@HeaderWndProc));//test 

  inherited;
  SetHeaderFont;//test//           
  SendMessage(hHeader, WM_SETFONT,  hHeaderFont, 1);//test//   
  SetTextColor(hHeader, Color2RGB(HFontColor));//test//    
  if _prop_HeaderFilterBar then SetWindowLong(hHeader,GWL_STYLE,GetWindowLong(hHeader,GWL_STYLE) or HDS_FILTERBAR);//test//     
  if not _prop_HeaderButtons then SetWindowLong(hHeader,GWL_STYLE,GetWindowLong(hHeader,GWL_STYLE) xor HDS_BUTTONS);//test//     ( ) 

  FBkColor                := Control.Color;
  FTextColor              := Control.Font.Color;
  FTextBkColor            := Control.Color;
  Control.LVBkColor       := FBkColor;
  Control.LVTextColor     := FTextColor;
  Control.LVTextBkColor   := FTextBkColor;
  Control.Tag             := Cardinal(Self);
  Control.AttachProc(WndProcTabGrid);
  Control.DoubleBuffered := _prop_DoubleBuffered;
end;

procedure ThiMTStrTbl.SetTextColLst;
begin
  CList := NewStrList;
  Clist.Text := Value;
end;

procedure ThiMTStrTbl.SetColumns;
var
  i: integer;
  s, str, sd: string;
begin
  if ListCol.Count = 0 then exit;
  i:= 0;
  Control.BeginUpdate;
  repeat
    s := ListCol.Items[i] + _ColDlm;
    sd := GetTok(s, _ColDlm);
    if sd <> '' then
    begin
      str := sd;
      case Mode of
        0: Control.LVColAdd(sd, FTextAlign, FColumnWidth);
        1: Control.LVColText[i] := sd;
      end;
      sd := GetTok(s, _ColDlm);
      if sd = '' then
        sd:= int2str(FColumnWidth)
      else
        Control.LVColWidth[i] := str2int(sd);
      str := str + _ColDlm + sd;
      sd := GetTok(s, _ColDlm);
      if FImgColumn and Assigned(SmIlist) and (SmIList.Count <> 0) then
        if sd = '' then
          Control.LVColImage[i] := I_SKIP
        else  
          Control.LVColImage[i] := str2int(sd);
      str := str + _ColDlm + sd;
      sd := GetTok(s, _ColDlm);
      if sd <> '' then
        Control.LVColAlign[i] := TTextAlign(str2int(sd))
      else
      begin
        Control.LVColAlign[i] := FTextAlign;
        sd := int2str(ord(Control.LVColAlign[i]));
      end;
      str := str + _ColDlm + sd;
      ListCol.Items[i] := str;
    end;
    inc(i);
  until i = ListCol.Count; 
  Control.EndUpDate;
end;

function ThiMTStrTbl.Get;
var
  d, s: PData;
  dt: TData;
  ColCount, Col, Colidx: integer;
begin
  dtNull(Result);
  if not ((Index >= 0) and (Index < Control.Count) and (Control.LVColCount > 0)) then exit;

  FreeData(@FData_1);
  dtNull(FData_1);
 
  ColCount := Control.LVColCount;
  if AssignIList then
    inc(ColCount);
  if FColorItems then   
    inc(ColCount);               

  Col := 0;
  ColIdx := 0;
  new(s);
  FillChar(s^, sizeof(TData), 0);
TRY
  if Assigned(PData(Control.LVItemData[Index])) then
    CopyData(s, PData(Control.LVItemData[Index])); 

  while Col < ColCount do 
  begin
    if (Col = FNIdxIcon) and AssignIList then
    begin
      dtInteger(dt, Control.LVItemImageIndex[Index]);
      AddMtData(@FData_1, @dt, d);
    end 
    else if (Col = FNColorRow) and FColorItems then
    begin
      dtInteger(dt, 0);
      if Assigned(PData(Control.LVItemData[Index])) then
      begin
        dt := s^;
        dt.ldata := nil;
      end;
      AddMtData(@FData_1, @dt, d);
    end
    else
     if ColIdx < Control.LVColCount then
    begin
      dtString(dt, CodePageGet(Control.LVItems[Index, ColIdx]));
      AddMtData(@FData_1, @dt, d);
      inc(ColIdx);
    end;
    inc(Col);
  end;

  if AssignIList and (FNIdxIcon < 0) then
  begin
    dtInteger(dt, Control.LVItemImageIndex[Index]);
    AddMtData(@FData_1, @dt, d);
  end;

  if Assigned(PData(Control.LVItemData[Index])) and (FColorItems and not (FNColorRow < 0)) and (s^.ldata <> nil) then
    AddMtData(@FData_1, s^.ldata, d)
  else if Assigned(PData(Control.LVItemData[Index])) and (not FColorItems or (FNColorRow < 0)) then
    AddMtData(@FData_1, s, d);

  Result := FData_1;

FINALLY
  case s^.Data_type of
    data_null: ;
    else
      FreeData(s);
  end;    
  Dispose(s);
END;
end;

//ItemAtPos -   ,    PosX, PosY  
//
procedure ThiMTStrTbl._var_ItemAtPos;
begin
   dtInteger(_Data, Control.LVItemAtPos(Ms.X, Ms.Y));
end;

//StringTable -    
//
procedure ThiMTStrTbl._var_MTStrTbl;
begin
  _Data.Data_type := data_int;
  _Data.sdata := 'StringTable';
  _Data.idata := integer(Control);
end;

procedure ThiMTStrTbl._var_HandleHeader; // test
begin
 dtInteger(_Data, hHeader);
end;

//#####################################################################
//#                                                                   #
//#                                                   #
//#                                                                   #
//#####################################################################

procedure ThiMTStrTbl._work_doNIdxIcon;
begin
  FNIdxIcon := ToInteger(_Data);
end;

procedure ThiMTStrTbl._work_doNColorRow;
begin
  FNColorRow := ToInteger(_Data);
end;

procedure ThiMTStrTbl.stextcolor;
begin
  FTextColor := value;
  Control.LVTextColor := Value;
end;

procedure ThiMTStrTbl.stextbkcolor;
begin
  FTextBkColor := Value;
  Control.LVTextBkColor := Value;
end;

procedure ThiMTStrTbl.sbkcolor;
begin
  FBkColor := Value;
  Control.LVBkColor := Value;
end;

procedure ThiMTStrTbl._work_doColor;
begin
  FBkColor := ToInteger(_Data);
  Control.LVBkColor := FBkColor;
end;

procedure ThiMTStrTbl._work_doStyle;
begin
  FStyle := TListViewStyle(ToInteger(_Data));
  Control.LVStyle := FStyle;
  SetColumns(Clist, 1);
end;

procedure ThiMTStrTbl._work_doEnableOnClick;
begin
  FEnableOnClick := ReadBool(_Data);
end;

procedure ThiMTStrTbl._work_doGrid;
begin
  FGrid := ReadBool(_Data);
  SetOption(FGrid, lvoGridLines);
end;

procedure ThiMTStrTbl._work_doTrackSelect;
begin
  FTrackSelect := ReadBool(_Data);
  SetOption(FTrackSelect, lvoTrackSelect);
end;

procedure ThiMTStrTbl._work_doMultiSelect;
begin
  FMultiSelect := ReadBool(_Data);
  SetOption(FMultiSelect, lvoMultiSelect);
end;

procedure ThiMTStrTbl._work_doInfoTip;
begin
  FInfoTip := ReadBool(_Data);
  SetOption(FInfoTip, lvoInfoTip);
end;

procedure ThiMTStrTbl.SetOption;
var
  l:TListViewOptions;
begin
  l := Control.LVOptions;
  if OSet then
    include(l, Option)
  else
    exclude(l, Option);
  Control.LVOptions := l;
end;

//#####################################################################
//#                                                                   #
//#                               #
//#                                                                   #
//#####################################################################

//------------------         --------------------

//ColumnArray -    
//
procedure ThiMTStrTbl.columnarray;
begin
  if not Assigned(CLArray) then
    CLArray := CreateArray(_SetCol, _GetCol, _CountCol, _AddCol);
  dtArray(_Data, CLArray);
end;

procedure ThiMTStrTbl._SetCol;
var
  s: string;
  ind: integer;
begin
  ind := ToIntIndex(Item);
  s := ToString(Val);
  if (ind >= 0) and (ind < CList.Count) then
    CList.Items[ind] := InitColStr(s);
  SetColumns(CList, 1);
end;

function ThiMTStrTbl._GetCol;
var
  ind: integer;
begin
  ind := ToIntIndex(Item);
  Result := True;
  if (ind >= 0) and (ind < CList.Count) then
    dtString(Val, Clist.Items[ind])
  else
    Result := False;
end;

procedure ThiMTStrTbl._AddCol;
var
  s: string;
begin
  s := ToString(Val);
  Control.LVColAdd('', FTextAlign, FColumnWidth);
  CList.Add(InitColStr(s));
  SetColumns(CList, 1);
end;

function ThiMTStrTbl._CountCol;
begin
  Result := CList.Count;
end;

//--------------------       -----------------------

//    
//
procedure ThiMTStrTbl.deletecol;
var
  ind: integer;
begin
  ind := ToInteger(_Data);
  if (ind >= 0) and (ind < CList.Count) then
  begin
    Control.LVColDelete(ind);
    CList.Delete(ind);
  end;
  SetColumns(CList,1);
end;

function ThiMTStrTbl.InitColStr;
var
  s, ss, sd, se, sf, sh: string;
begin
  s := val;
  sf := s + _ColDlm;
  ss := GetTok(sf, _ColDlm);
  sd := GetTok(sf, _ColDlm);
  sh := GetTok(sf, _ColDlm);
  se := GetTok(sf, _ColDlm);
  if s <> '' then
  begin
    if sd = '' then sd := int2str(FColumnWidth);
    if se = '' then se := int2str(integer(FTextAlign));
    s := ss + _ColDlm + sd + _ColDlm + sh + _ColDlm + se;
  end;
  Result := s;
end;

//#####################################################################
//#                                                                   #
//#                                                #
//#                                                                   #
//#####################################################################

//Matrix -  
//
procedure ThiMTStrTbl.Matrix;
begin
  if not Assigned(Obj) then
  begin
    New(Obj);
    Obj._Set  := MX_Set;
    Obj._Get  := MX_Get;
    Obj._Rows := _mRows; 
    Obj._Cols := _mCols; 
  end;
  dtMatrix(_Data, Obj);
end;

function ThiMTStrTbl.MX_Get;
begin
  if (x >= 0) and (y >= 0) and (y < Control.Count) and (x < Control.LVColCount) then
    dtString(Result, Control.LVItems[y,x])
  else
    dtNull(Result);
end;

procedure ThiMTStrTbl.MX_Set;
begin
  if (x >= 0) and (y >= 0) and (y < Control.Count) and (x < Control.LVColCount) then
    Control.LVItems[y,x] := ToString(Val);
end;

function ThiMTStrTbl._mRows;
begin
  Result := Control.Count; 
end;

function ThiMTStrTbl._mCols;
begin
  Result := Control.LVColCount; 
end;

//#####################################################################
//#                                                                   #
//#                           MT-                               #
//#                                                                   #
//#####################################################################

//  MT-    
//
procedure ThiMTStrTbl.ActionItm; // 
var
  Row, Col, ColIdx, ColCount: integer;
  fd, s: PData;
  dc, ds: TData;
begin
  case Data.Data_type of
    data_null: exit;
  end;
  dtNull(dc);
  case Mode of
    ITM_REPLACE:
    begin
      Row := ReadInteger(Data, Null);
      if (Row > Control.Count - 1) and (Row < 0) then exit;
    end;
    ITM_INSERT:
    begin
      Row := ReadInteger(Data, Null);
      if (Row > Control.Count) and (Row < -1) then exit
      else if Row = -1 then
        Row := Control.Count; 
      Control.LVItemInsert(Row, '');
    end    
    else
    begin
      Row := Control.Count;
      Control.LVItemInsert(Row, '');
    end;  
  end;
  Col := 0;
  ColIdx := 0;
  ColCount := Control.LVColCount; 

  if AssignIList then
    inc(ColCount);
  if FColorItems then   
    inc(ColCount);               

  while Col < ColCount do
  begin
    if ((ColIdx <> FNIdxIcon) or not AssignIList) and ((ColIdx <> FNColorRow) or not FColorItems) then
    begin 
      if Col < Control.LVColCount then
      begin
        if Assigned(_data_CodePageSet.Event) then
        begin
          dtString(ds, ReadString(Data, Null));
          _ReadData(ds, _data_CodePageSet);
          Control.LVItems[Row, Col] := ToString(ds);
        end  
        else
          Control.LVItems[Row, Col] := ReadString(Data, Null);
      end;
      inc(Col);
    end  
    else if (ColIdx = FNIdxIcon) and AssignIList then
      Control.LVItemImageIndex[Row]:= ReadInteger(Data, Null)
    else if (ColIdx = FNColorRow) and FColorItems then
      dc := ReadData(Data, Null);
    inc(ColIdx);
  end;

  case Data.Data_type of
    data_null: ;
    else
    begin
      if AssignIList and (FNIdxIcon < 0) then
        Control.LVItemImageIndex[Row]:= ReadInteger(Data, Null);
    end        
  end;
  AddMTData(@dc, @Data, s);

TRY  
  case dc.Data_type of
    data_null: exit;
  end;
  if Assigned(PData(Control.LVItemData[Row])) then
  begin
    fd := PData(Control.LVItemData[Row]);
    FreeData(fd);
  end
  else
  begin
    new(fd);
    FillChar(fd^, sizeof(TData), 0);
  end;    
  CopyData(fd, @dc);
  Control.LVItemData[Row] := cardinal(fd);
FINALLY  
  FreeData(s);
END;
end;

// MT-   
//
procedure ThiMTStrTbl.ActionCol; // 
var
  s: string;
  ind: integer;
begin
  case Data.Data_type of
    data_null: exit;
  end;
  ind := ReadInteger(Data, Null); 
  s := ReadString(Data, Null);   
  case Mode of
    ITM_INSERT:
      if ind >= 0 then
        if (ind > CList.Count - 1) then
        begin
          Control.LVColAdd('', FTextAlign, FColumnWidth);
          CList.Add(InitColStr(s));
        end
        else
        begin
          Control.LVColInsert(ind, '', FTextAlign, FColumnWidth);
          CList.Insert(ind, InitColStr(s));
        end;
    ITM_REPLACE:
      if (ind >= 0) and (ind < CList.Count) then
        CList.Items[ind] := InitColStr(s)
    else
      exit;
  end;    
  SetColumns(CList, 1);
end;

// MT-    
//
procedure ThiMTStrTbl.ProperCol; // 
var
  s, name, width, imgidx, aligntxt: string;
  ind: integer;
begin
  case Data.Data_type of
    data_null: exit;
  end;
  ind := ReadInteger(Data, Null);   
  s := ReadString(Data, Null);   
  if (ind < 0) or (ind > CList.Count - 1) then exit;
  name := Control.LVColText[ind];
  width := int2str(Control.LVColWidth[ind]);
  imgidx := int2str(Control.LVColImage[ind]);
  aligntxt := int2str(ord(Control.LVColAlign[ind]));  
  case Mode of 
    COL_NAME:  name := s;
    COL_WIDTH: width := s;
    COL_IMAGE: imgidx := s;
    COL_ALIGN: aligntxt := s;
    else
      exit;   
  end;
  s := name + _ColDlm + width + _ColDlm + imgidx + _ColDlm + aligntxt;
  CList.Items[ind] := InitColStr(s);
  SetColumns(CList, 1);
end;

//   ,     
//
procedure ThiMTStrTbl._var_TopItem;
begin
  dtInteger(_Data, Control.LVTopItem);
end;

//    ,    
//
procedure ThiMTStrTbl._var_PerPage;
begin
  dtInteger(_Data, Control.LVPerPage);
end;

//     
//
procedure ThiMTStrTbl._var_Count;
begin
  dtInteger(_Data, Control.Count);
end;

//      
//
procedure ThiMTStrTbl._var_EndIdx;
begin
  if Control.Count = 0 then
    dtNull(_Data)
  else
    dtInteger(_Data, Control.Count - 1);
end;

//   ,
//   -   MT-    
//
procedure ThiMTStrTbl._var_Select;
begin
  if Control.LVCurItem = -1 then
     dtNull(_Data)
   else
     _Data := Get(Control.LVCurItem); 
end;

//    
//
procedure ThiMTStrTbl._var_Index;
begin
  dtInteger(_Data, Control.CurIndex);
end;

//   
//
procedure ThiMTStrTbl._var_CountCol;
begin
  dtInteger(_Data, CList.Count);
end;

//      
//
procedure ThiMTStrTbl._var_EndIdxCol;
begin
  if CList.Count = 0 then
    dtNull(_Data)
  else
    dtInteger(_Data, CList.Count - 1);
end;

//    
//
procedure ThiMTStrTbl.SetLargIconsManager;
begin
  if value <> nil then
  begin
    FLargIconsManager := value;
    LgIList := value.iconList;
    if Assigned(Control) then
      Control.ImageListNormal := LgIList;
  end;
end;

procedure ThiMTStrTbl.SetSmallIconsManager;
begin
  if value <> nil then
  begin
    FSmallIconsManager := value;
    SmIList := value.iconList; 
    FImgSize := value.imgsz;
    SmIList.BkColor := FIconColColor;
    Control.ImageListSmall := SmIList;
    SetColumns(CList,1);  
  end;
end;

procedure ThiMTStrTbl.SetStateIconsManager;
begin
  if value <> nil then
  begin
    FStateIconsManager := value;
    StIList := value.iconList;
    if Assigned(Control) then
      Control.ImageListState := StIList;
  end;
end;

procedure ThiMTStrTbl._work_doClientRect;
var
  Row,Col: integer;
  R, ARect: TRect;
  dTop, dWidth, dHeight, Data: TData;
  b: integer;
begin
  Row := ReadInteger(_Data, _data_Row, _prop_Row);
  Col := ReadInteger(_Data, _data_Col, _prop_Col);
  R := Control.LVSubItemRect(Row, Col);
  if Col = 0 then
  begin
    ARect := Control.LVItemRect(Row, lvipLabel);
    R.Left := ARect.Left;
    R.Right := ARect.Right;
  end; 
  if not boolean(_prop_CTL3D) then
    b := 2
  else
    b := 1;

  dtInteger(Data, R.Left + Control.Left + b);
  dtInteger(dWidth, R.Right - R.Left - 1);
  dtInteger(dTop, R.Top + Control.Top + b);
  dtInteger(dHeight, R.Bottom - R.Top - 1);

  Data.ldata:= @dTop;
  dTop.ldata:= @dWidth;
  dWidth.ldata:= @dHeight;
  _hi_OnEvent_(_event_onClientRect, Data);
end;

procedure ThiMTStrTbl._work_doHeaderSizing;
begin
bHeaderSizing := ReadBool(_data);
end;

procedure ThiMTStrTbl._work_doNoSizingColumns;
begin
NoSizingColumns(ToString(_data));
end;

procedure ThiMTStrTbl.NoSizingColumns;//test
var s,sd: string;
    ind: integer;
begin
    SetLength(ArrNoSizCol,0);
    if Length(Val) = 0 then exit; 
    ind := 0;
    s := Val + ',';
    repeat
     sd := GetTok(s, ',');
     if sd <> '' then begin
      SetLength(ArrNoSizCol,ind + 1);
      ArrNoSizCol[ind] := str2int(sd);
      inc(ind); 
     end else break;
    until false;
end;

procedure ThiMTStrTbl._work_doClearFilter;//test//      (-1   )
const  HDM_CLEARFILTER   = HDM_FIRST + 24;
var i: integer;
begin
 i := ToInteger(_Data);
 SendMessage(hHeader,HDM_CLEARFILTER, WPARAM(i),0);
end;

procedure ThiMTStrTbl._work_doFilterTime;//test//      
const HDM_SETFILTERCHANGETIMEOUT = HDM_FIRST + 22; 
var i: integer;
begin
 i := ToInteger(_Data);
 SendMessage(hHeader,HDM_SETFILTERCHANGETIMEOUT, 0, LPARAM(i));
end;

procedure ThiMTStrTbl.SetHeaderFont;//test
var lf: TLogFont;
begin
    FillChar(lf, sizeof(lf), #0);
    lstrcpy(lf.lfFaceName,PChar(_prop_FontHeader.Name));
    lf.lfHeight := _prop_FontHeader.Size;
    lf.lfCharSet := _prop_FontHeader.CharSet;
    if _prop_FontHeader.Style and 1 > 0 then lf.lfWeight := 700   else lf.lfWeight := 0;
    if _prop_FontHeader.Style and 2 > 0 then lf.lfItalic := 1     else lf.lfItalic := 0;   
    if _prop_FontHeader.Style and 4 > 0 then lf.lfUnderline := 1  else lf.lfUnderline := 0;   
    if _prop_FontHeader.Style and 8 > 0 then lf.lfStrikeOut := 1  else lf.lfStrikeOut := 0;   
    hHeaderFont := CreateFontIndirect(lf);             //  
    HFontColor := _prop_FontHeader.Color;              //   
end;

//----------------------------      ------------------------------
end.